/****************************************************************************** 
 * Job:             Load_STG2DM_Prf_sales_fact              A5W0V4GZ.BF0004KX * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Sourabh/My Folder/M1Devp                           * 
 *                                                                            * 
 * Server:          MIMain                                  A5W0V4GZ.AR000003 * 
 *                                                                            * 
 * Source Tables:   STG_PRF_SALES - stg_lib.STG_PRF_SALES  A5W0V4GZ.BB0009LP  * 
 *                  DATE_DM - DI_DM.DATE_DM                 A5W0V4GZ.BB0009QJ * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0009N1 * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB0009R9 * 
 *                  PRF_SALES_FACT - DI_DM.PRF_SALES_FACT   A5W0V4GZ.BB0009TI * 
 * Target Tables:   PRF_SALES_FACT - DI_DM.PRF_SALES_FACT   A5W0V4GZ.BB0009TI * 
 *                  PRF_SALES_FACT_META -                   A5W0V4GZ.BB0009TJ * 
 *                   DI_DM.PRF_SALES_FACT_META                                * 
 *                                                                            * 
 * Generated on:    Thursday, April 29, 2010 2:25:03 PM IST                   * 
 * Generated by:    singyg@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5W0V4GZ.BF0004KX);
%let etls_jobName = %nrquote(Load_STG2DM_Prf_sales_fact);
%let etls_userID = %nrquote(singyg@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            UW Pre-process                          A5W0V4GZ.BH000ME2 * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_PRF_SALES - stg_lib..STG_PRF_SALES  A5W0V4GZ.BB0009LP * 
 * Target Table:    UW Pre-process - stg_lib..STG_PRF_SALES A5W0V4GZ.BK000ILW * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%macro Uw_pre_process;

%global g_meta_table_obs g_date_lvl excp_tab;
%local abort;

%let excp_tab = Stg_prf_sales_x_&part_sk;
%put exception table = &excp_tab;

/**********************************************************/
/****Check for existence of DI_MON.PROD_HIER_SK dataset****/
/**********************************************************/

%if NOT %sysfunc(exist(DI_MON.PROD_HIER_SK)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_MON.PROD_HIER_SK);
   %put &etl_msg;
   %let abort=1;
%end;

%else %do;
   %let product_dm_obs = %di_util_nobs(DI_MON.PROD_HIER_SK);
   %if &product_dm_obs = 0 %then 
   %do;
       %let etl_msg = %etl_msg(mid=5008,args=DI_MON.PROD_HIER_SK);
       %put &etl_msg;
   %end;
%end;

%di_etl_rcset(error=&syserr,code=job_rc);

/*******************************************************/
/***Check for existence of DI_DM.GEOGRAPHY_DM dataset***/
/*******************************************************/

%if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_DM);
   %put &etl_msg;
   %let abort=2;
%end;

%else %do;
   %let geography_dm_obs = %di_util_nobs(DI_DM.GEOGRAPHY_DM);
   %if &geography_dm_obs = 0 %then 
   %do;
      %let etl_msg = %etl_msg(mid=5008,args=DI_DM.GEOGRAPHY_DM);
      %put &etl_msg;
   %end;
%end;

%di_etl_rcset(error=&syserr,code=job_rc);

/*******************************************************/
/***Check for existence of DI_DM.DATE_DM dataset***/
/*******************************************************/

%if NOT %sysfunc(exist(DI_DM.DATE_DM)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.DATE_DM);
   %put &etl_msg;
   %let abort=3;
%end;

%else %do;
   %let date_dm_obs = %di_util_nobs(DI_DM.DATE_DM);
   %if &date_dm_obs = 0 %then 
   %do;
      %let etl_msg = %etl_msg(mid=5008,args=DI_DM.DATE_DM);
      %put &etl_msg;
   %end;
%end;

%di_etl_rcset(error=&syserr,code=job_rc);

/*******************************************************/
/***  Check whether this job is executed standalone  ***/
/*******************************************************/

%if %sysfunc(libref(err_lib)) ne 0  or 
    %sysfunc(libref(trg_lib)) ne 0  or 
    %sysfunc(libref(stg_lib)) ne 0 %then %do;
      %put ERROR : The job &etls_jobName cannot be executed standalone. please execute it with di_etl_load_partition macro.;
       %put ERROR : Exiting execution....;
       %let abort = 4;
%end;

/*****************************************/
/*Abort in case preconditions are not met*/
/*****************************************/

%if &abort > 0 %then %do;
   %etl_abort;
%end;

/*create meta table if does not exist.*/
%if NOT %sysfunc(exist(di_dm.Prf_sales_fact_meta)) %then 
%do;
    data di_dm.Prf_sales_fact_meta;
    attrib PART_SK length = 6   ;
    attrib PROD_HIER_SK length = 6   ;
    attrib START_ROW length = 6   ;
    attrib END_ROW length = 6   ;
    stop; run;

   proc sql;
      create index prod_hier_sk on di_dm.Prf_sales_fact_meta(prod_hier_sk);
   quit;

%end;
%let g_meta_table_obs = %di_util_nobs(di_dm.Prf_sales_fact_meta);


proc sql noprint ;
   select max(date_lvl) into :g_date_lvl from di_dm.date_dm;
quit;

/******************************************/
/*create error table if it does not exist.*/
/******************************************/

%if NOT %sysfunc(exist(err_lib.&excp_tab)) %then 
%do;

   %di_util_lock(di_mon.stg_prf_sales_x);

   data err_lib.&excp_tab;
      set di_mon.stg_prf_sales_x;
      stop;
   run;

   %di_util_unlock(di_mon.stg_prf_sales_x);

%end;

/*******************************************/
/*create status table if it does not exist.*/
/*******************************************/

%if not %sysfunc( exist(err_lib.job_status)) %then %do;
   %di_util_lock(di_mon.job_status);
   data err_lib.job_status;
      set di_mon.job_status;
      stop;
   run;
   %di_util_unlock(di_mon.job_status);
%end;

/*Set exception table and exception records for job_status macro*/
%let etlp_exception_table=ERR_LIB.&excp_tab; 
%put etlp_exception_table=&etlp_exception_table;

data _null_; 
    call symput('etl_xobsbefore', %di_util_nobs(&etlp_exception_table));
run;

%mend Uw_pre_process;

%Uw_pre_process
/*---- End of User Written Code  ----*/ 

%di_etl_rcSet(error=&syserr,code=job_rc); 


/**  Step end UW Pre-process **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Lk_stg_prf_sales                        A5W0V4GZ.BH000HHY * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   UW Pre-process - stg_lib.STG_PRF_SALES A5W0V4GZ.BK000EB6 * 
 *                  DATE_DM - DI_DM.DATE_DM                 A5W0V4GZ.BB0007ZK * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0007U1 * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB000809 * 
 * Target Table:    Lk_stg_prf_sales -                      A5W0V4GZ.BK000EB7 * 
 *                   work.Lk_stg_prf_sales                                    * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 
%let trans_rc = 0;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview0;
quit;

proc sql; create view etls_temp_lookupview0 as 
   select * from DI_DM.DATE_DM
   where DATE_LVL =&g_date_lvl;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lk_stg_prf_sales;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lk_stg_prf_sales
         ( keep = PROD_ID GEO_ID START_DT END_DT SALES_UNITS SALES_AMT PROD_HIER_SK 
                 GEO_HIER_SK DATE_SK CHANGE_FLG)
      ; 
   
   attrib PROD_ID length=$32
          GEO_ID length=$32
          START_DT length=8 format=DATE9.
          END_DT length=8 format=DATE9.
          SALES_UNITS length=8 format=NLNUM12.2
          SALES_AMT length=8 format=NLNUM20.3
          PROD_HIER_SK length=6
          GEO_HIER_SK length=4
          DATE_SK length=4
          FISCAL_START_DT length= 8
          FISCAL_END_DT length= 8
		  CHANGE_FLG length=$1
          ; 
   
   retain missing0-missing2 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table etls_temp_lookupview0 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview0"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "etls_temp_lookupview0", hashexp: exponent);
            h0.defineKey( "FISCAL_START_DT",
                           "FISCAL_END_DT");
            h0.defineData( "DATE_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview0";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview0";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview0";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview0";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table DI_MON.PROD_HIER_SK */ 
      nlobs = .; 
      dsid = open("di_mon.PROD_HIER_SK"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "di_mon.PROD_HIER_SK", hashexp: exponent);
            h1.defineKey( "PROD_ID");
            h1.defineData( "PROD_HIER_SK");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: err_lib.PROD_HIER_SK";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: di_mon.PROD_HIER_SK";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " di_mon.PROD_HIER_SK";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " di_mon.PROD_HIER_SK";
         
         abort 3; 
      end; 
      
      /* Build hash h2 from lookup table DI_DM.GEOGRAPHY_DM */ 
      nlobs = .; 
      dsid = open("DI_DM.GEOGRAPHY_DM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h2(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
            h2.defineKey( "GEO_ID");
            h2.defineData( "GEO_HIER_SK");
            h2.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h2.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing2 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
            missing2 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.GEOGRAPHY_DM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.GEOGRAPHY_DM";
         
         abort 3; 
      end; 
      
      call missing (FISCAL_START_DT, FISCAL_END_DT, DATE_SK, PROD_ID, PROD_HIER_SK, 
                    GEO_ID, GEO_HIER_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set stg_lib.STG_PRF_SALES_&part_sk end = eof;
   if missing(END_DT) then 
   do;
   END_DT=START_DT +6;
  end;   

   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      FISCAL_START_DT = START_DT;
      FISCAL_END_DT = END_DT;
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      rc1 = h1.find();
   end; 
   else 
      rc1 = missing1; 
      
   /* Is the current key value stored in hash h2?  */ 
   if (missing2 < 1) then 
   do; 
      rc2 = h2.find();
   end; 
   else 
      rc2 = missing2; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 and rc1=0 and rc2=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lk_stg_prf_sales; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (DATE_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (DATE_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc2 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc2 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (GEO_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (GEO_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lk_stg_prf_sales; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%di_etl_rcSet(error=&syserr,code=job_rc); 


/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Val_stg_prf_sales                       A5W0V4GZ.BH000ME4 * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lk_stg_prf_sales -                      A5W0V4GZ.BK000ILX * 
 *                   work.Lk_stg_prf_sales                                    * 
 * Target Table:    Data Validation Target -                A5W0V4GZ.BK000ILY * 
 *                   work.Val_stg_prf_sales                                   * 
 *============================================================================*/ 

/*---- Start of Pre-Process Code  ----*/ 
%di_etl_keep_work_table(Lk_stg_prf_sales);
/*---- End of Pre-Process Code  ----*/ 

%di_etl_rcSet(error=&syserr,code=job_rc); 

%macro etls_Validate; 

   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_stg_prf_sales ;
   quit;
   
   %let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 
   
     
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.Val_stg_prf_sales
         (keep = PROD_ID GEO_ID START_DT END_DT SALES_UNITS SALES_AMT 
                         PROD_HIER_SK GEO_HIER_SK DATE_SK CHANGE_FLG)
        work.etls_Errors
         (keep = PROD_ID GEO_ID START_DT END_DT SALES_UNITS SALES_AMT 
                         ETLS_EXCEPTION_COND CHANGE_FLG);
   
      /* Define lengths for columns with longer lengths in target  */ 
      attrib ETLS_EXCEPTION_COND length = $200; 
      
      set Lk_stg_prf_sales end=eof;
      
   
       /*---- Custom Validation: Invalid PROD_ID  ----*/ 
      if (MISSING(PROD_HIER_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5305,args=PROD_ID)"),$200.); 
      end;  /* if (MISSING(PROD_HIER_SK)) */
      
      /*---- Custom Validation: Invalid GEO_ID  ----*/ 
      if (MISSING(GEO_HIER_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5305,args=GEO_ID)"),$200.); 
      end;  /* if (MISSING(GEO_HIER_SK)) */
      
      /*---- Custom Validation: Invalid DATE_SK  ----*/ 
      if (MISSING(DATE_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5305,args=START_DT/END_DT)"),$200.); 
      end;  /* if (MISSING(DATE_SK)) */
      
      /*---- Custom Validation: negative or zero sales units  ----*/ 
      if (SALES_UNITS  <= 0) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5331,args=SALES_UNITS 0)"),$200.); 
      end;  /* if (SALES_UNITS  <= 0) */
      
      /*---- Custom Validation: negative sales amount  ----*/ 
      if (SALES_AMT  < 0) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5328,args=SALES_AMT 0)"),$200.); 
      end;  /* if (SALES_AMT  < 0) */

	  if CHANGE_FLG = 'd' then CHANGE_FLG = 'D';
       
      /*---- Custom Validation: Remove duplicate records  ----*/ 
      if (ETLS_EXCEPTION_COND ne "") then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.Val_stg_prf_sales;
   run; 
   
  %di_etl_rcSet(error=&syserr,code=job_rc); 
   
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append data=WORK.etls_Errors
               base=err_lib.&excp_tab force;   
   run;
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
%mend etls_Validate;
%etls_Validate;

/*---- End of Post-Process Code  ----*/ 

%di_etl_rcSet(error=&syserr,code=job_rc); 

/**  Step end Val_stg_prf_sales **/

/*============================================================================* 
 * Step:            Sort_stg_prf_sales                      A5W0V4GZ.BH000ME6 * 
 * Transform:       Sort                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Uw_extract_part_sk -                    A5W0V4GZ.BK000ILZ * 
 *                   work.Uw_extract_part_sk                                  * 
 * Target Table:    Sort_stg_prf_sales -                    A5W0V4GZ.BK000IM0 * 
 *                   work.Sort_stg_prf_sales                                  * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

/*---- Start of Pre-Process Code  ----*/ 
%di_etl_keep_work_table(Val_stg_prf_sales);
/*---- End of Pre-Process Code  ----*/ 

%di_etl_rcSet(error=&syserr,code=job_rc); 

/*---- Start of User Written Code  ----*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Sort_stg_prf_sales;
quit;

proc sort data = Val_stg_prf_sales 
   out = work.Sort_stg_prf_sales(drop = PROD_ID GEO_ID START_DT END_DT) NODUPKEY
   dupout = stg_prf_sales_xx; 
   by
      PROD_HIER_SK
      GEO_HIER_SK
      DATE_SK
   ;
run; 

data stg_prf_sales_xx;
   set stg_prf_sales_xx;
   attrib ETLS_EXCEPTION_COND length=$200;
   attrib ETL_ERROR_JOBRUNTIME length=8 format= datetime16.;
   ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5303,args=record)"),$200.); 
   ETL_ERROR_JOBRUNTIME=%sysfunc(datetime());
run;

proc append base=err_lib.&excp_tab
            data=WORK.STG_PRF_SALES_XX
            (keep=%di_util_column_names(err_lib.&excp_tab)) force;
run;

/*---- End of User Written Code  ----*/ 

%di_etl_rcSet(error=&syserr,code=job_rc);  


/**  Step end Sort_stg_prf_sales **/

/*============================================================================* 
 * Step:            Uw_load_prf_sales_fact                  A5W0V4GZ.BH000ME7 * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Sort_stg_prf_sales -                    A5W0V4GZ.BK000IM0 * 
 *                   work.Sort_stg_prf_sales                                  * 
 * Target Table:    PRF_SALES_FACT - DI_DM.PRF_SALES_FACT   A5W0V4GZ.BB0009TI * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 
 
 %macro call_sendjobstatus;
   %let etls_recordsBefore = %di_util_nobs(trg_lib.PRF_SALES_FACT);
   %let etls_recordsafter = %di_util_nobs(trg_lib.PRF_SALES_FACT);
   %let etls_table =  %str(PRF_SALES_FACT);
   %let etls_lib   = %str(d_&part_sk);
   %let etls_endTime = %sysfunc(datetime(),datetime.);
   %put NOTE : There were no valid observations to process.;
   %etls_sendjobstatus(source_table = stg_lib.STG_PRF_SALES_&part_sk,dataset = err_lib.job_status);
%mend call_sendjobstatus;

%macro chk_indx;

   proc contents data = trg_lib.PRF_SALES_FACT out = tmp_contents noprint;
   run;
   %local idxcnt;

   proc sql noprint;
     select max(idxcount) into :idxcnt
       from tmp_contents;
   quit;

   %if &idxcnt < 1 %then %do;

      proc datasets library=trg_lib nolist;
         modify PRF_SALES_FACT;
         index create prod_hier_sk;
      quit;

      %di_etl_rcSet(error=&syserr,code=job_rc); 

   %end;
   %else %do;
      %put index already present. no need to recreate;
   %end;


%mend chk_indx;

%macro Load_prf_sales_fact;

   %if %di_util_nobs(Sort_stg_prf_sales) = 0 %then 
   %do;
      %call_sendjobstatus;
   %return;
   %end;

   %let etls_recordsBefore = %di_util_nobs(trg_lib.PRF_SALES_FACT);
   %if &etls_recordsBefore = 0 %then %do;
   	   data trg_lib.PRF_SALES_FACT(drop = CHANGE_FLG);
          set Sort_stg_prf_sales;
          if change_flg = "&etl_delete_flg" then delete;
       run;
   %end;
   %else %do;
    
   data trg_lib.PRF_SALES_FACT(drop = CHANGE_FLG);
      merge trg_lib.PRF_SALES_FACT
            Sort_stg_prf_sales;
      by PROD_HIER_SK GEO_HIER_SK DATE_SK;
	  if change_flg = "&etl_delete_flg" then delete;
   run;
   %end;

    %di_etl_rcSet(error=&syserr,code=job_rc); 

   %let etls_recordsafter = %di_util_nobs(trg_lib.PRF_SALES_FACT);

   %put etls_recordsBefore = &etls_recordsBefore;
   %put etls_recordsafter = &etls_recordsafter;

   %let etls_table = %nrquote(PRF_SALES_FACT);
   %let etls_lib   = %nrquote(d_&part_sk);
   %let etls_endTime = %sysfunc(datetime(),datetime.);
   %etls_sendjobstatus(source_table = stg_lib.STG_PRF_SALES_&part_sk,
                        dataset = err_lib.job_status);

    data map (keep = PART_SK PROD_HIER_SK START_ROW END_ROW);
      set trg_lib.PRF_SALES_FACT;
      attrib part_sk length = 6;
      attrib START_ROW length = 6;
       attrib END_ROW length = 6;
      PART_SK = &part_sk;
      by PROD_HIER_SK;
      retain START_ROW;
      if first.PROD_HIER_SK then do;
         START_ROW = _n_;
      end;
      if last.PROD_HIER_SK then do;
        END_ROW = _n_;
        output;
      end;
    run;

  %di_etl_rcSet(error=&syserr,code=job_rc); 

  %di_util_lock(di_dm.Prf_sales_fact_meta);

  proc sql;
     delete from di_dm.Prf_sales_fact_meta 
      where part_sk = &part_sk;
  quit;

   proc append data = map 
      base = di_dm.Prf_sales_fact_meta force;
   run;

   %di_util_unlock(di_dm.Prf_sales_fact_meta);

   %di_etl_rcSet(error=&syserr,code=job_rc); 

   /*---- Create index for the partition ----*/

%chk_indx;

%di_etl_rcSet(error=&syserr,code=job_rc); 

%mend Load_prf_sales_fact;

%Load_prf_sales_fact;

%let etls_endTime = %sysfunc(datetime(),datetime.);

libname err_lib clear;
libname stg_lib clear;
libname trg_lib clear;
